/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: chop.cc,v 1.2 1994/08/19 18:10:31 bengt Exp $ */

// This rounds its first argument to second-argument significant digits.
// If optional third argument is true, truncates instead of rounds.

// Not written to be particularly efficient...

#include "externals.h"
#include "gnanslib.h"

extern void
chop(double &x, int digits, int truncate)
{
  if (digits < 1)
    gnans_error(non_fatal,
		"Can't chop to a nonpositive number of significant digits");
  double mult = pow(10, digits - int(log10(x)) - 1);
  x = int(x * mult + (truncate ? 0 : 0.5))/mult;
}

#ifdef MAIN
#include <stream.h>
#include <stdlib.h>
main(int argc, char *argv[])
{
  double x = atof(argv[1]);
  chop(x, atoi(argv[2]));
  cout << x << "\n";
  x = atof(argv[1]);
  chop(x, atoi(argv[2]), 1);
  cout << x << "\n";
}
#endif
