/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: histo.h,v 1.6 1994/02/14 22:25:51 bengt Exp $ */

#ifndef _histo_h
#define _histo_h

#ifdef __GNUG__
#pragma interface
#endif

#define CHECK_HISTO

class histo {
  unsigned int dimension;
  double xmin, xmax, ymin, ymax;
  unsigned int xbins, ybins;
  long int *data;
  bool include_faroff;
  std::string matrixname;
  std::string filename;

  bool matlab_write(FILE *f);
  bool ascii_write(FILE *f);
  bool float_write(FILE *f);

 public:
  histo();
  histo(double xmin, double xmax,
	double ymin, double ymax,
	int xbins, int ybins, bool include_faroff,
	char *matrixname, char *filename);
  histo(double xmin, double xmax, int xbins, bool include_faroff,
	char *matrixname, char *filename);
  void open(double xmin, double xmax,
	    double ymin, double ymax,
	    int xbins, int ybins, bool include_faroff,
	    char *matrixname, char *filename);
  void open(double xmin, double xmax, int xbins, bool include_faroff,
	char *matrixname, char *filename);
  void close();
  void update(double x);
  void update(double x, double y);
  double chi_2(double N);
};

#endif
