/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: terminate.cc,v 1.6 1993/09/19 11:29:41 bengt Exp $ */

/*
 * Defines a function which, when called with a nun-null argument, terminates
 * the run. Returns its argument, cast to double.
 */

// throw_away_last_point does not work.

#include "externals.h"
//#include "gnanslib.h"

extern double 
terminate(int term, int throw_away_last_point = 0)
{
  if (term) {
    running_integration = false;
    if (throw_away_last_point)
      floating_point_error_occured = true;
  }
  return (double) term;
}
