/* -*- c++ -*-
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id:  $

// This acts as an abstract base class for some integration routines
// by Hindmarsh and co-workers. Drivers for Lsode and Vode are implemented
// as classes derived from this base class.

#ifndef _HIntegrator_h
#define _HIntegrator_h

#ifdef __GNUG__
#pragma interface
#endif

#include "CIntegrator.h"

class HindmarshIntegrator : public ContinuousIntegrator {
public:
  bool loop(bool initialize);
  HindmarshIntegrator();

private:
  virtual bool make_setup(int flag) = 0;
  bool initialize_integrator();

protected:
  // Note: the following variable names are from the Fortran code,
  // I did NOT select them...
  // Their meaning is defined in the Fortran code.
  int neqn, itask, istate, *iwork, itol, iopt, mf, lrw, liw;
  double tout, *rwork;
};

#endif
