/* -*- c++ -*-
 Copyright (C) 1994 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: Rksuite.h, Exp $

#ifndef _Rksuite_h
#define _Rksuite_h

#ifdef __GNUG__
#pragma interface
#endif

#include "CIntegrator.h"

class RksuiteIntegrator : public ContinuousIntegrator {
public:
  const char *documentation() const;
  bool loop(bool initialize);
  RksuiteIntegrator();
private:
  bool initialize_integrator();
  bool call_integrator();
  int neqn;			// Number of states
  int cflag;			// Communication variable
  int method;			// method flag
  int lenwrk;			// Length of array work
  int mesage;			// Do I want verbose message from algo?
  int lenint;			// Length wrkint
  double *work;
  double *ypnow;
  double *thres;
  double *wrkint;
};

#endif
