#include "externals.h"
#include "Lsode10.h"
#include "Lsode22.h"
#include "Vode10.h"
#include "Vode22.h"
#include "Rkf45.h"
#include "Rksuite23.h"
#include "Rksuite45.h"
#include "Rksuite78.h"
#include "Ode.h"
#include "Rkfix.h"
#include "Euler.h"
#include "Euler-Maru.h"
#include "Newton.h"
#include "Vode.h"

#define TABLESIZE 14
#define ALGORITHM(Class) algorithms[i] = new Class; i++

extern void
integrators_setup()
{
  unsigned int i = 0;
  typedef ContinuousIntegrator *ContinuousIntegratorPtr;
  algorithms = new ContinuousIntegratorPtr[TABLESIZE];

  ALGORITHM(Lsode10Integrator);
  ALGORITHM(Lsode22Integrator);
  ALGORITHM(Vode10Integrator);
  ALGORITHM(Vode22Integrator);
  ALGORITHM(Rksuite23Integrator);
  ALGORITHM(Rksuite45Integrator);
  ALGORITHM(Rksuite78Integrator);
  ALGORITHM(Rkf45Integrator);
  ALGORITHM(OdeIntegrator);
  ALGORITHM(RkfixIntegrator);
  ALGORITHM(EulerIntegrator);
  ALGORITHM(EulerMaruyamaIntegrator);
  ALGORITHM(NewtonIntegrator);

  algorithms[i] = NULL;

  if (i >= TABLESIZE)
    gnans_error(impossible, "TABLESIZE too small");
};

