/* -*- c++ -*-
Copyright  1993 Bengt Mrtensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

// $Id: StoreFormat.h,v 1.3 1994/01/30 20:50:11 bengt Exp $

#ifndef _Store_Format_h
#define _Store_Format_h

// REWRITE ME
/**************** Data stucture for a store format ****************/
class StoreFormat {
public:
  // Scratch pointer to a Widget 
  void *widget;		

  // Name of format as it appears in menus etc 
  const char * /*const*/ name;
  
  // File name extension to be used 
  const char * /*const*/ extension;
  
  // Pointer to a function returning true iff the format can be used with
  // present parameters. If the argument is true, should present an 
  // error message
  bool (*check)(bool complain); 

  // Pointer to a function doing the actual writing 	
  bool (*write)();

  // A documentation string 
  const char * /*const*/ documentation;
  
  //StoreFormat();		// Presently undefined
};

#endif
