#ifndef _Symrec_h
#define _Symrec_h

/* Data type for links in the chain of symbols. */
class symrec {
  double *var;                  /* value of a VAR  */
  bool precious_var;            /* Did I get var from someone */
 public:
  char *name;                   /* name of symbol */
  int type;                     /* type of symbol: either VAR or FNCT */
  bool readonly;                /* Read/write or readonly */
  double (*fnctptr)(double x);  /* value of a FNCT */
  symrec *next;                 /* link field */
  symrec(const char *sym_name, int sym_type, bool ro, symrec *next_ptr);
  ~symrec();
  operator int()        { return int(*var); }
  operator double()     { return *var; }
  symrec& operator=(double v)   { *var = v; return *this; }
  symrec& operator=(double *v_ptr);

  void print();
};

#endif
