/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse zzparse
#define yylex   zzlex
#define yyerror zzerror
#define yylval  zzlval
#define yychar  zzchar
#define yydebug zzdebug
#define yynerrs zznerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     FLOAT = 258,
     INT = 259,
     ID = 260,
     ID8 = 261,
     STRING = 262,
     COMMENT = 263,
     C_BLOCK = 264,
     CONTINUOUS = 265,
     DISCRETE = 266,
     HYBRID = 267,
     DAS = 268,
     RICCATI = 269,
     TIME = 270,
     SYSTEM = 271,
     STATE = 272,
     INTEGERSTATE = 273,
     INTEGER = 274,
     DOUBLE = 275,
     PARAMETER = 276,
     FUNCTION = 277,
     VARIABLE = 278,
     UNIFORM = 279,
     NORMAL = 280,
     WHITE = 281,
     NOISE = 282,
     WIENER = 283,
     PROCESS = 284,
     EVENT = 285,
     MATRIX = 286,
     VECTOR = 287,
     C_IDENTIFIER = 288,
     FILEREAD = 289,
     ATTIME = 290,
     OR = 291,
     AND = 292,
     NE = 293,
     EQ = 294,
     LE = 295,
     GE = 296,
     GG = 297,
     LL = 298,
     MINUSMINUS = 299,
     PLUSPLUS = 300,
     UPLUS = 301,
     UMINUS = 302
   };
#endif
#define FLOAT 258
#define INT 259
#define ID 260
#define ID8 261
#define STRING 262
#define COMMENT 263
#define C_BLOCK 264
#define CONTINUOUS 265
#define DISCRETE 266
#define HYBRID 267
#define DAS 268
#define RICCATI 269
#define TIME 270
#define SYSTEM 271
#define STATE 272
#define INTEGERSTATE 273
#define INTEGER 274
#define DOUBLE 275
#define PARAMETER 276
#define FUNCTION 277
#define VARIABLE 278
#define UNIFORM 279
#define NORMAL 280
#define WHITE 281
#define NOISE 282
#define WIENER 283
#define PROCESS 284
#define EVENT 285
#define MATRIX 286
#define VECTOR 287
#define C_IDENTIFIER 288
#define FILEREAD 289
#define ATTIME 290
#define OR 291
#define AND 292
#define NE 293
#define EQ 294
#define LE 295
#define GE 296
#define GG 297
#define LL 298
#define MINUSMINUS 299
#define PLUSPLUS 300
#define UPLUS 301
#define UMINUS 302




/* Copy the first part of user declarations.  */
#line 1 "parser.yy"

/*
 Copyright (C) 1992 Bengt Martensson and Institute for Dynamical Systems.

This file is part of Gnans.

Gnans is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2, or (at your option) any later
version.

Gnans is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Gnans; see the file COPYING.  If not, write to the 
Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/* $Id: parser.y,v 1.30 1994/11/01 12:53:43 bengt Exp bengt $ */

/* Debugging support enabled -- also in production versions */
#define YYDEBUG 1

#include <config.h>
#include "translator.h"
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <utillib.h>
#include <stdlib.h>
#ifndef YYBISON
extern void cfree(generic_ptr ptr);
#define free(p) cfree((generic_ptr) p)
#endif

#define STR_EQUAL(s1, s2) (! strcmp((s1), (s2)))
#define FLOATFMT "%0.16e"

static char dummy_string[] = NODESCRIPTION;
static unsigned int current_time_index = 0;
static char *current_drift = NULL;
static deprec *current_drift_dependencies = NULL;

static char *original_unary_functions[] = {
  "sin",
  "cos",
  "tan",
  "ceil",
  "floor",
  "atan",
  "asin",
  "acos",
  "abs",
  "fabs",
  "log",
  "log10",
  "exp",
  "sqrt",

  /* Defined in gnanslib.h */
  "sqr",
  "cube",
  "heaviside",
  
  ""};

static char *original_binary_functions[] = {
  "atan2",
  "max",
  "min",
  ""};

static char **unary_functions = original_unary_functions;
static char **binary_functions = original_binary_functions;

unsigned int 
size(char **s)
{
  return **s == '\0' ? 0 : size(s + 1) + 1;
}

static void
add_function(char **&functions, char *fname)
{
  unsigned int s = size(functions);
  char **new_functions = new char*[s+2];
  for (unsigned int i = 0; i < s; i++)
    new_functions[i] = functions[i];
  //delete(functions);
  functions = new_functions;
  functions[s] = fname;
  functions[s+1] = stringify("");
}

static void
add_unary_function(char *fname)
{
  add_function(unary_functions, fname);
}

static void
add_binary_function(char *fname)
{
  add_function(binary_functions, fname);
}

/*
 * Increments function_calls, unless the calling function is well-known.
 */
static void 
increment_function_calls(char *function_name, int number_of_args)
{
  /* Check number of args if the function is known to us */
  int i;
  for (i = 0; unary_functions[i][0]; i++)
    if (! strcmp(unary_functions[i], function_name)) {
      if (number_of_args != 1)
	gnans_error(semantic, "``%s'' called with wrong number of arguments",
		    function_name);
      return;
    }
  for (i = 0; binary_functions[i][0]; i++)
    if (! strcmp(binary_functions[i], function_name)) {
      if (number_of_args != 2)
	gnans_error(semantic, "``%s'' called with wrong number of arguments",
		    function_name);
      return;
    }

  /* Check if the name is in the symbol table */
  if (getsym(function_name) && getsym(function_name)->type != Defun)
    gnans_error(semantic,
		"`%s' can't be used as a function (forgotten `*'?)",
		function_name);

  function_calls++;
}

/* Check that we don't overfill tables of size MAXSTATES */
/* (Yes, this is bad programming...) */
static void
check_size(const unsigned int size,
	   const unsigned int max_size = SMALLTABLESIZE)
{
  if (size >= max_size) {
    gnans_error(fatal,
		"Internal limit exceeded, sorry (MAXSTATES or SMALLTABLESIZE too small).");
    if (translator_debug)
      abort();
  }
}

static bool
current_block_compare(unsigned int block)
{
  return current_block == &(times_buffer[block]);
}

#define operation stringify


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 164 "parser.yy"
typedef union YYSTYPE {
  double value;
  char *text;
  int keyword;
  int integer;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 348 "parser.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 360 "parser.cc"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   825

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  73
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  78
/* YYNRULES -- Number of rules. */
#define YYNRULES  174
/* YYNRULES -- Number of states. */
#define YYNSTATES  403

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    56,     2,     2,     2,    55,    42,     2,
      64,    65,    53,    52,    63,    51,    70,    54,    69,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    38,    66,
      45,    36,    46,    37,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    71,     2,    72,    62,     2,     2,     2,     2,     2,
      67,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    68,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    41,     2,    57,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    39,    40,    43,    44,    47,    48,    49,    50,    58,
      59,    60,    61
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     9,    10,    13,    15,    17,    19,    21,
      23,    24,    27,    31,    35,    36,    38,    40,    46,    50,
      52,    54,    56,    64,    74,    82,    83,    86,    88,    90,
      92,    94,    96,    98,   100,   102,   104,   123,   131,   139,
     144,   149,   158,   159,   163,   166,   168,   174,   181,   182,
     185,   187,   189,   191,   196,   199,   202,   206,   211,   218,
     227,   230,   234,   238,   242,   246,   250,   253,   256,   259,
     262,   265,   268,   271,   274,   278,   282,   286,   290,   294,
     298,   302,   306,   310,   314,   318,   322,   326,   330,   336,
     338,   342,   344,   348,   352,   356,   360,   365,   369,   371,
     373,   375,   377,   379,   381,   383,   389,   395,   401,   406,
     411,   413,   415,   417,   419,   421,   423,   425,   427,   429,
     431,   433,   435,   439,   441,   445,   450,   465,   480,   484,
     486,   490,   495,   497,   499,   501,   505,   507,   511,   516,
     531,   546,   550,   552,   556,   559,   563,   565,   569,   571,
     575,   577,   581,   583,   589,   591,   595,   600,   606,   608,
     612,   617,   622,   624,   628,   633,   634,   636,   638,   641,
     643,   646,   647,   650,   652
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      74,     0,    -1,   149,   106,    75,    78,    77,    -1,    -1,
      75,    76,    -1,   113,    -1,   105,    -1,    83,    -1,   150,
      -1,     1,    -1,    -1,    77,    78,    -1,    79,    80,    87,
      -1,    35,     5,    38,    -1,    -1,     9,    -1,     5,    -1,
      81,    63,    81,    63,    81,    -1,    81,    63,    82,    -1,
      84,    -1,    85,    -1,    86,    -1,     5,    64,    81,    65,
      36,    99,    66,    -1,     5,    64,    81,    63,    81,    65,
      36,    99,    66,    -1,     5,    64,    82,    65,    36,    99,
      66,    -1,    -1,    87,    88,    -1,    90,    -1,    94,    -1,
      91,    -1,    92,    -1,    89,    -1,    93,    -1,   113,    -1,
     150,    -1,     1,    -1,    67,    64,     5,    65,    36,    14,
      64,     5,    63,     5,    63,     5,    63,     5,    63,     5,
      65,    66,    -1,    67,    64,     5,    65,    36,    99,    66,
      -1,    68,    64,     5,    65,    36,    99,    66,    -1,     5,
      36,    99,    66,    -1,     4,    36,    99,    66,    -1,    67,
      64,     5,    65,    36,    96,    95,    66,    -1,    -1,    95,
      52,    96,    -1,    95,    97,    -1,    69,    -1,    98,    67,
      64,     5,    65,    -1,    51,    98,    67,    64,     5,    65,
      -1,    -1,    99,    53,    -1,     3,    -1,     4,    -1,     5,
      -1,    68,    64,     5,    65,    -1,   102,    99,    -1,   103,
      99,    -1,   100,    64,    65,    -1,   100,    64,    99,    65,
      -1,   100,    64,    99,    63,    99,    65,    -1,   100,    64,
      99,    63,    99,    63,   101,    65,    -1,     5,   104,    -1,
      99,    52,    99,    -1,    99,    51,    99,    -1,    99,    53,
      99,    -1,    99,    54,    99,    -1,    99,    55,    99,    -1,
      59,     5,    -1,    58,     5,    -1,     5,    59,    -1,     5,
      58,    -1,    51,    99,    -1,    52,    99,    -1,    56,    99,
      -1,    57,    99,    -1,    99,    62,    99,    -1,    64,    99,
      65,    -1,    99,    50,    99,    -1,    99,    49,    99,    -1,
      99,    44,    99,    -1,    99,    43,    99,    -1,    99,    47,
      99,    -1,    99,    48,    99,    -1,    99,    45,    99,    -1,
      99,    46,    99,    -1,    99,    42,    99,    -1,    99,    41,
      99,    -1,    99,    40,    99,    -1,    99,    39,    99,    -1,
      99,    37,    99,    38,    99,    -1,     5,    -1,   100,    70,
       5,    -1,    99,    -1,   101,    63,    99,    -1,    64,    19,
      65,    -1,    64,    20,    65,    -1,    71,    99,    72,    -1,
     104,    71,    99,    72,    -1,    15,     5,    66,    -1,   108,
      -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,     5,
      -1,     6,    -1,    10,    15,    16,   107,    66,    -1,    11,
      15,    16,   107,    66,    -1,    12,    15,    16,   107,    66,
      -1,    13,    16,   107,    66,    -1,    14,    16,   107,    66,
      -1,   114,    -1,   120,    -1,   123,    -1,   129,    -1,   132,
      -1,   138,    -1,   141,    -1,   144,    -1,   135,    -1,   115,
      -1,   118,    -1,   119,    -1,    17,   116,    66,    -1,   117,
      -1,   117,    63,   116,    -1,     5,    36,   148,   147,    -1,
      17,    32,     5,    36,    34,    64,     5,    63,   147,    63,
     147,    65,   147,    66,    -1,    17,    31,     5,    36,    34,
      64,     5,    63,   147,    63,   147,    65,   147,    66,    -1,
      18,   121,    66,    -1,   122,    -1,   122,    63,   121,    -1,
       5,    36,     4,   147,    -1,   124,    -1,   127,    -1,   128,
      -1,    21,   125,    66,    -1,   126,    -1,   126,    63,   125,
      -1,     5,    36,   148,   147,    -1,    21,    32,     5,    36,
      34,    64,     5,    63,   147,    63,   147,    65,   147,    66,
      -1,    21,    31,     5,    36,    34,    64,     5,    63,   147,
      63,   147,    65,   147,    66,    -1,    22,   130,    66,    -1,
     131,    -1,   131,    63,   130,    -1,     5,   147,    -1,    23,
     133,    66,    -1,   134,    -1,   134,    63,   133,    -1,     5,
      -1,    33,   136,    66,    -1,   137,    -1,   137,    63,   136,
      -1,     5,    -1,    24,    26,    27,   139,    66,    -1,   140,
      -1,   140,    63,   139,    -1,     5,    36,     4,   147,    -1,
      25,    26,    27,   142,    66,    -1,   143,    -1,   143,    63,
     142,    -1,     5,    36,     4,   147,    -1,    28,    29,   145,
      66,    -1,   146,    -1,   146,    63,   145,    -1,     5,    36,
       4,   147,    -1,    -1,     7,    -1,     3,    -1,    51,     3,
      -1,     4,    -1,    51,     4,    -1,    -1,   149,   150,    -1,
      66,    -1,     8,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   236,   236,   239,   240,   243,   244,   245,   246,   247,
     250,   251,   254,   257,   271,   272,   275,   280,   282,   286,
     287,   288,   291,   302,   313,   324,   325,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   339,   402,   445,   477,
     507,   511,   557,   558,   559,   562,   565,   597,   629,   630,
     633,   634,   635,   636,   638,   640,   642,   644,   646,   649,
     652,   654,   655,   656,   657,   658,   659,   660,   661,   662,
     663,   664,   665,   666,   667,   669,   670,   671,   672,   673,
     674,   675,   676,   677,   678,   679,   680,   681,   682,   685,
     686,   689,   690,   694,   697,   700,   701,   705,   715,   716,
     717,   718,   719,   722,   723,   727,   733,   739,   744,   749,
     754,   755,   756,   757,   758,   759,   760,   761,   762,   766,
     767,   768,   771,   774,   775,   778,   788,   793,   817,   820,
     821,   824,   834,   835,   836,   839,   842,   843,   846,   857,
     862,   882,   885,   886,   889,   898,   901,   902,   905,   913,
     916,   917,   920,   925,   928,   929,   932,   945,   948,   949,
     952,   965,   968,   969,   972,   987,   988,   996,   997,   998,
     999,  1001,  1002,  1004,  1005
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "FLOAT", "INT", "ID", "ID8", "STRING", 
  "COMMENT", "C_BLOCK", "CONTINUOUS", "DISCRETE", "HYBRID", "DAS", 
  "RICCATI", "TIME", "SYSTEM", "STATE", "INTEGERSTATE", "INTEGER", 
  "DOUBLE", "PARAMETER", "FUNCTION", "VARIABLE", "UNIFORM", "NORMAL", 
  "WHITE", "NOISE", "WIENER", "PROCESS", "EVENT", "MATRIX", "VECTOR", 
  "C_IDENTIFIER", "FILEREAD", "ATTIME", "'='", "'?'", "':'", "OR", "AND", 
  "'|'", "'&'", "NE", "EQ", "'<'", "'>'", "LE", "GE", "GG", "LL", "'-'", 
  "'+'", "'*'", "'/'", "'%'", "'!'", "'~'", "MINUSMINUS", "PLUSPLUS", 
  "UPLUS", "UMINUS", "'^'", "','", "'('", "')'", "';'", "'d'", "'q'", 
  "'0'", "'.'", "'['", "']'", "$accept", "system", "decls", "decl", 
  "time_blocks", "time_block", "time_header", "C_block", "formal_param", 
  "formal_param_list", "function_def", "unary_function_def", 
  "binary_function_def", "general_function_def", "equations", "equation", 
  "ricc_eqn", "diff_eqn", "difference_eqn", "alg_eqn", "implicit_eqn", 
  "stoch_diff_eqn", "diffusions", "diffusion", "minus_diffusion", 
  "multiplier", "exp", "fname", "arglist", "int_cast", "double_cast", 
  "bracket_args", "time_decl", "system_decl", "latin1id", 
  "continuous_system", "discrete_system", "hybrid_system", "das_system", 
  "riccati_system", "component_decl", "state_decl", "scalar_states_decl", 
  "scalar_states", "scalar_state_decl", "vector_state_decl", 
  "matrix_state_decl", "int_state_decl", "int_states", "int_state", 
  "par_decl", "scalar_par_decl", "scalar_pars", "scalar_par", 
  "vector_par_decl", "matrix_par_decl", "func_decl", "functs_decl", 
  "func", "var_decl", "vars_decls", "var_dec", "id_decl", "id_decls", 
  "id", "u_noise_decl", "u_noises_decl", "u_noise", "n_noise_decl", 
  "n_noises_decl", "n_noise", "wiener_decl", "wieners_decl", "wiener", 
  "string", "real", "pass_thrus", "pass_thru", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,    61,    63,    58,   291,
     292,   124,    38,   293,   294,    60,    62,   295,   296,   297,
     298,    45,    43,    42,    47,    37,    33,   126,   299,   300,
     301,   302,    94,    44,    40,    41,    59,   100,   113,    48,
      46,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    73,    74,    75,    75,    76,    76,    76,    76,    76,
      77,    77,    78,    79,    80,    80,    81,    82,    82,    83,
      83,    83,    84,    85,    86,    87,    87,    88,    88,    88,
      88,    88,    88,    88,    88,    88,    89,    90,    91,    92,
      93,    94,    95,    95,    95,    96,    96,    97,    98,    98,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,   100,
     100,   101,   101,   102,   103,   104,   104,   105,   106,   106,
     106,   106,   106,   107,   107,   108,   109,   110,   111,   112,
     113,   113,   113,   113,   113,   113,   113,   113,   113,   114,
     114,   114,   115,   116,   116,   117,   118,   119,   120,   121,
     121,   122,   123,   123,   123,   124,   125,   125,   126,   127,
     128,   129,   130,   130,   131,   132,   133,   133,   134,   135,
     136,   136,   137,   138,   139,   139,   140,   141,   142,   142,
     143,   144,   145,   145,   146,   147,   147,   148,   148,   148,
     148,   149,   149,   150,   150
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     5,     0,     2,     1,     1,     1,     1,     1,
       0,     2,     3,     3,     0,     1,     1,     5,     3,     1,
       1,     1,     7,     9,     7,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,    18,     7,     7,     4,
       4,     8,     0,     3,     2,     1,     5,     6,     0,     2,
       1,     1,     1,     4,     2,     2,     3,     4,     6,     8,
       2,     3,     3,     3,     3,     3,     2,     2,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     5,     1,
       3,     1,     3,     3,     3,     3,     4,     3,     1,     1,
       1,     1,     1,     1,     1,     5,     5,     5,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     3,     4,    14,    14,     3,     1,
       3,     4,     1,     1,     1,     3,     1,     3,     4,    14,
      14,     3,     1,     3,     2,     3,     1,     3,     1,     3,
       1,     3,     1,     5,     1,     3,     4,     5,     1,     3,
       4,     4,     1,     3,     4,     0,     1,     1,     2,     1,
       2,     0,     2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
     171,     0,     0,     1,   174,     0,     0,     0,     0,     0,
     173,     3,    98,    99,   100,   101,   102,   172,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,     0,
       0,     9,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     4,    10,    14,     7,    19,    20,
      21,     6,     5,   110,   119,   120,   121,   111,   112,   132,
     133,   134,   113,   114,   118,   115,   116,   117,     8,     0,
       0,     0,   108,   109,     0,     0,     0,     0,     0,     0,
     123,     0,     0,   129,     0,     0,     0,     0,   136,   165,
       0,   142,   148,     0,   146,     0,     0,     0,   152,     0,
     150,     0,     2,    15,    25,   105,   106,   107,    16,     0,
       0,    97,     0,     0,     0,   122,     0,     0,   128,     0,
       0,     0,     0,   135,     0,   166,   144,   141,     0,   145,
       0,     0,     0,     0,     0,   162,   149,     0,    13,    11,
       0,     0,     0,     0,   167,   169,     0,   165,     0,     0,
     124,   165,   130,   165,     0,     0,   137,   143,   147,     0,
       0,   154,     0,     0,   158,     0,   161,     0,   151,    35,
       0,     0,     0,     0,    26,    31,    27,    29,    30,    32,
      28,    33,    34,     0,    18,     0,     0,   168,   170,   125,
       0,     0,   131,   138,     0,     0,     0,   153,     0,     0,
     157,     0,   165,   163,     0,     0,     0,     0,     0,     0,
      50,    51,    52,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     165,   155,   165,   159,   164,     0,     0,     0,     0,    17,
       0,    69,    68,     0,    60,    70,    71,    72,    73,    67,
      66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,     0,     0,    54,    55,    24,
       0,     0,     0,     0,   156,   160,    40,    39,     0,     0,
       0,     0,     0,    93,    94,    75,     0,     0,    87,    86,
      85,    84,    79,    78,    82,    83,    80,    81,    77,    76,
      62,    61,    63,    64,    65,    74,    56,     0,    90,   165,
     165,   165,   165,    48,     0,    23,    95,     0,    53,     0,
       0,    57,     0,     0,     0,     0,     0,    45,    42,     0,
       0,     0,    96,    88,     0,   165,   165,   165,   165,     0,
       0,     0,    49,    37,    38,     0,    58,     0,     0,     0,
       0,     0,    48,    48,    41,    44,     0,    91,     0,   165,
     165,   165,   165,     0,     0,     0,    43,     0,     0,    59,
       0,     0,     0,     0,     0,     0,    46,    92,   127,   126,
     140,   139,     0,     0,     0,     0,     0,    47,     0,     0,
       0,     0,    36
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,    23,    44,   102,    45,    46,   104,   109,   184,
      47,    48,    49,    50,   140,   174,   175,   176,   177,   178,
     179,   180,   350,   338,   365,   339,   312,   222,   368,   223,
     224,   244,    51,    11,    29,    12,    13,    14,    15,    16,
      52,    53,    54,    79,    80,    55,    56,    57,    82,    83,
      58,    59,    87,    88,    60,    61,    62,    90,    91,    63,
      93,    94,    64,    99,   100,    65,   160,   161,    66,   163,
     164,    67,   134,   135,   126,   147,     2,    17
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -168
static const short yypact[] =
{
    -168,    20,    51,  -168,  -168,     7,    30,    36,    42,    52,
    -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,    54,    55,
      61,    27,    27,     6,    27,    27,    27,  -168,  -168,     0,
       1,  -168,    14,    74,     4,    76,    11,    77,    79,    81,
      83,    84,   105,   109,  -168,  -168,    94,  -168,  -168,  -168,
    -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,
    -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,    60,
      64,    71,  -168,  -168,   122,    88,   107,   140,   150,    92,
      96,   125,   102,   101,   133,   165,   166,   120,   124,   182,
     127,   128,  -168,   131,   142,   163,   167,   201,  -168,   141,
     145,   171,   175,  -168,  -168,  -168,  -168,  -168,  -168,   -60,
     147,  -168,     9,   179,   180,  -168,   212,   223,  -168,    76,
       9,   196,   204,  -168,   237,  -168,  -168,  -168,    77,  -168,
      79,   238,   239,   211,   183,   185,  -168,   105,  -168,  -168,
     111,   122,   216,   226,  -168,  -168,    50,   182,   231,   232,
    -168,   182,  -168,   182,   249,   250,  -168,  -168,  -168,   251,
     222,   233,   258,   229,   236,   293,  -168,   201,  -168,  -168,
     264,   265,   240,   241,  -168,  -168,  -168,  -168,  -168,  -168,
    -168,  -168,  -168,   -55,  -168,   256,   256,  -168,  -168,  -168,
     242,   245,  -168,  -168,   246,   247,   299,  -168,   238,   312,
    -168,   239,   182,  -168,   256,   256,   313,   314,   122,   281,
    -168,  -168,    16,   256,   256,   256,   256,   316,   317,   234,
     278,   354,   -20,   256,   256,   382,   338,   339,   340,   341,
     182,  -168,   182,  -168,  -168,   410,   438,   282,   284,   287,
     256,  -168,  -168,   256,   280,   290,   290,   290,   290,  -168,
    -168,   288,   289,   604,   350,   256,   256,   256,   256,   256,
     256,   256,   256,   256,   256,   256,   256,   256,   256,   256,
     256,   256,   256,   256,  -168,   199,   351,   290,   290,  -168,
     315,   318,   321,   322,  -168,  -168,  -168,  -168,   343,   344,
     466,   286,   256,  -168,  -168,  -168,   311,   633,   704,   227,
     725,   745,   763,   763,    98,    98,    98,    98,    69,    69,
     130,   130,   290,   290,   290,   290,  -168,   550,  -168,   182,
     182,   182,   182,   162,   256,  -168,  -168,   320,  -168,   256,
     256,  -168,   323,   324,   325,   326,   319,  -168,  -168,   310,
     494,   522,  -168,   657,   577,   182,   182,   182,   182,   385,
     -26,   346,   256,  -168,  -168,   256,  -168,   347,   348,   349,
     352,   355,   256,   177,  -168,  -168,   406,   657,   -48,   182,
     182,   182,   182,   433,   372,   681,  -168,   375,   256,  -168,
     376,   377,   379,   380,   378,   402,  -168,   657,  -168,  -168,
    -168,  -168,   462,   463,   407,   404,   468,  -168,   408,   469,
     429,   430,  -168
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -168,  -168,  -168,  -168,  -168,   393,  -168,  -168,  -139,   423,
    -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,  -168,
    -168,  -168,  -168,   135,  -168,    53,  -167,  -168,  -168,  -168,
    -168,  -168,  -168,  -168,   116,  -168,  -168,  -168,  -168,  -168,
     359,  -168,  -168,   386,  -168,  -168,  -168,  -168,   403,  -168,
    -168,  -168,   399,  -168,  -168,  -168,  -168,   373,  -168,  -168,
     394,  -168,  -168,   388,  -168,  -168,   328,  -168,  -168,   329,
    -168,  -168,   360,  -168,  -147,   409,  -168,   -22
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -90
static const short yytable[] =
{
     189,    68,   183,   141,   192,   142,   193,    31,   208,    76,
     209,    32,   144,   145,     4,   378,    84,   379,   221,   225,
       3,    33,    18,    34,    35,   362,   363,    36,    37,    38,
      39,    40,    27,    28,    41,    77,    78,   235,   236,    42,
     364,    43,    85,    86,   275,    19,   245,   246,   247,   248,
     276,    20,   253,   187,   188,   234,   277,   278,    21,     4,
     146,     5,     6,     7,     8,     9,    72,    73,    22,   239,
      24,    25,    10,   290,   241,   242,   291,    26,    74,    75,
     -89,    81,    89,   284,    92,   285,   -89,   243,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   103,   313,   314,   315,    95,   317,    96,
      98,   -12,   169,    97,   101,   170,   171,    10,   182,     4,
     268,   269,   270,   271,   272,   327,   105,   108,    34,    35,
     106,   273,    36,    37,    38,    39,    40,   107,    30,    41,
      69,    70,    71,   112,    42,   113,   -12,   266,   267,   268,
     269,   270,   271,   272,   111,   114,   340,   341,   115,   116,
     273,   117,   343,   344,   119,   210,   211,   212,   118,   120,
     121,   122,   332,   333,   334,   335,   336,    10,   172,   173,
     210,   211,   212,   270,   271,   272,   123,   124,   367,   125,
     131,   128,   273,   127,   132,   375,   375,   129,   357,   358,
     359,   360,   210,   211,   212,   130,   133,   136,   137,   138,
      43,   387,   143,   213,   214,   148,   149,    76,   215,   216,
     217,   218,   380,   381,   382,   383,   219,   151,   213,   214,
     220,   337,   154,   215,   216,   217,   218,   210,   211,   212,
     155,   219,    84,   159,   162,   220,   337,   165,   167,   166,
     213,   214,   185,   251,   252,   215,   216,   217,   218,   210,
     211,   212,   186,   219,   316,   190,   191,   220,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,   194,   195,   213,   214,   196,   197,   273,
     215,   216,   217,   218,   199,   200,   198,   202,   219,   201,
     204,   205,   220,   230,   206,   207,   226,   213,   214,   227,
     228,   229,   215,   216,   217,   218,   232,   240,   237,   238,
     219,   249,   250,   255,   220,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   254,   280,   281,   282,   283,   288,   273,   289,
     208,   292,   273,   293,   294,   296,   318,   255,   326,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   328,   351,   319,   323,
     324,   320,   273,   349,   321,   322,   345,   346,   347,   348,
     361,   255,   342,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     366,   377,   369,   370,   371,   374,   273,   372,   373,   255,
     274,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   384,   385,
     386,   392,   388,   389,   273,   390,   391,   255,   279,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,   393,   394,   395,   397,
     396,   399,   273,   398,   400,   255,   286,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   401,   139,   402,   110,   376,   181,
     273,   157,   150,   255,   287,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,   269,   270,
     271,   272,   152,   156,   158,   168,   231,   203,   273,   153,
     233,   255,   325,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   352,   271,   272,
       0,     0,     0,     0,     0,     0,   273,     0,     0,   255,
     353,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,     0,     0,
       0,     0,     0,     0,   273,     0,     0,   255,   354,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,   270,   271,   272,     0,     0,     0,     0,
       0,     0,   273,   330,   255,   331,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,     0,     0,     0,     0,     0,   273,
     355,   255,   356,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,     0,     0,     0,     0,     0,   273,     0,     0,   295,
     255,   329,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
       0,     0,     0,     0,   255,   273,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,   271,   272,     0,     0,     0,     0,     0,   255,   273,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   352,   271,   272,     0,     0,     0,
       0,     0,     0,   273,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
       0,     0,     0,     0,     0,     0,   273,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,     0,     0,     0,     0,     0,   273,   260,   261,
     262,   263,   264,   265,   266,   267,   268,   269,   270,   271,
     272,     0,     0,     0,     0,     0,     0,   273,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,     0,
       0,     0,     0,     0,     0,   273
};

static const short yycheck[] =
{
     147,    23,   141,    63,   151,    65,   153,     1,    63,     5,
      65,     5,     3,     4,     8,    63,     5,    65,   185,   186,
       0,    15,    15,    17,    18,    51,    52,    21,    22,    23,
      24,    25,     5,     6,    28,    31,    32,   204,   205,    33,
      66,    35,    31,    32,    64,    15,   213,   214,   215,   216,
      70,    15,   219,     3,     4,   202,   223,   224,    16,     8,
      51,    10,    11,    12,    13,    14,    66,    66,    16,   208,
      16,    16,    66,   240,    58,    59,   243,    16,    64,     5,
      64,     5,     5,   230,     5,   232,    70,    71,   255,   256,
     257,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,   269,     9,   271,   272,   273,    26,   275,    26,
       5,     0,     1,    29,     5,     4,     5,    66,   140,     8,
      51,    52,    53,    54,    55,   292,    66,     5,    17,    18,
      66,    62,    21,    22,    23,    24,    25,    66,    22,    28,
      24,    25,    26,    36,    33,     5,    35,    49,    50,    51,
      52,    53,    54,    55,    66,     5,   323,   324,    66,    63,
      62,    36,   329,   330,    63,     3,     4,     5,    66,    36,
       5,     5,   319,   320,   321,   322,    14,    66,    67,    68,
       3,     4,     5,    53,    54,    55,    66,    63,   355,     7,
      27,    63,    62,    66,    27,   362,   363,    66,   345,   346,
     347,   348,     3,     4,     5,    63,     5,    66,    63,    38,
      35,   378,    65,    51,    52,    36,    36,     5,    56,    57,
      58,    59,   369,   370,   371,   372,    64,     4,    51,    52,
      68,    69,    36,    56,    57,    58,    59,     3,     4,     5,
      36,    64,     5,     5,     5,    68,    69,    36,    63,    66,
      51,    52,    36,    19,    20,    56,    57,    58,    59,     3,
       4,     5,    36,    64,    65,    34,    34,    68,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    34,    34,    51,    52,    36,    66,    62,
      56,    57,    58,    59,    36,    66,    63,     4,    64,    63,
      36,    36,    68,     4,    64,    64,    64,    51,    52,    64,
      64,    64,    56,    57,    58,    59,     4,    36,     5,     5,
      64,     5,     5,    37,    68,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    64,     5,     5,     5,     5,    65,    62,    65,
      63,    71,    62,    65,    65,     5,     5,    37,    72,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    65,    67,    63,    36,
      36,    63,    62,    64,    63,    63,    63,    63,    63,    63,
       5,    37,    72,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      64,     5,    65,    65,    65,   362,    62,    65,    63,    37,
      66,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,     5,    67,
      65,    63,    66,    66,    62,    66,    66,    37,    66,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    64,     5,     5,    65,
      63,    63,    62,     5,     5,    37,    66,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    65,   102,    66,    74,   363,   140,
      62,   128,   116,    37,    66,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,   119,   124,   130,   137,   198,   167,    62,   120,
     201,    37,    66,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    37,
      66,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    -1,    -1,
      -1,    -1,    -1,    -1,    62,    -1,    -1,    37,    66,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    63,    37,    65,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    62,
      63,    37,    65,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,    65,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    37,    62,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    -1,    -1,    -1,    -1,    -1,    37,    62,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      -1,    -1,    -1,    -1,    -1,    -1,    62,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    62,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    -1,    -1,    -1,    -1,    -1,    -1,    62,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    74,   149,     0,     8,    10,    11,    12,    13,    14,
      66,   106,   108,   109,   110,   111,   112,   150,    15,    15,
      15,    16,    16,    75,    16,    16,    16,     5,     6,   107,
     107,     1,     5,    15,    17,    18,    21,    22,    23,    24,
      25,    28,    33,    35,    76,    78,    79,    83,    84,    85,
      86,   105,   113,   114,   115,   118,   119,   120,   123,   124,
     127,   128,   129,   132,   135,   138,   141,   144,   150,   107,
     107,   107,    66,    66,    64,     5,     5,    31,    32,   116,
     117,     5,   121,   122,     5,    31,    32,   125,   126,     5,
     130,   131,     5,   133,   134,    26,    26,    29,     5,   136,
     137,     5,    77,     9,    80,    66,    66,    66,     5,    81,
      82,    66,    36,     5,     5,    66,    63,    36,    66,    63,
      36,     5,     5,    66,    63,     7,   147,    66,    63,    66,
      63,    27,    27,     5,   145,   146,    66,    63,    38,    78,
      87,    63,    65,    65,     3,     4,    51,   148,    36,    36,
     116,     4,   121,   148,    36,    36,   125,   130,   133,     5,
     139,   140,     5,   142,   143,    36,    66,    63,   136,     1,
       4,     5,    67,    68,    88,    89,    90,    91,    92,    93,
      94,   113,   150,    81,    82,    36,    36,     3,     4,   147,
      34,    34,   147,   147,    34,    34,    36,    66,    63,    36,
      66,    63,     4,   145,    36,    36,    64,    64,    63,    65,
       3,     4,     5,    51,    52,    56,    57,    58,    59,    64,
      68,    99,   100,   102,   103,    99,    64,    64,    64,    64,
       4,   139,     4,   142,   147,    99,    99,     5,     5,    81,
      36,    58,    59,    71,   104,    99,    99,    99,    99,     5,
       5,    19,    20,    99,    64,    37,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    62,    66,    64,    70,    99,    99,    66,
       5,     5,     5,     5,   147,   147,    66,    66,    65,    65,
      99,    99,    71,    65,    65,    65,     5,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    65,    99,     5,    63,
      63,    63,    63,    36,    36,    66,    72,    99,    65,    38,
      63,    65,   147,   147,   147,   147,    14,    69,    96,    98,
      99,    99,    72,    99,    99,    63,    63,    63,    63,    64,
      95,    67,    53,    66,    66,    63,    65,   147,   147,   147,
     147,     5,    51,    52,    66,    97,    64,    99,   101,    65,
      65,    65,    65,    63,    98,    99,    96,     5,    63,    65,
     147,   147,   147,   147,     5,    67,    65,    99,    66,    66,
      66,    66,    63,    64,     5,     5,    63,    65,     5,    63,
       5,    65,    66
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 13:
#line 257 "parser.yy"
    {
  unsigned int i;
  for (i = 0; i < number_of_times; i++) {
    if (STR_EQUAL(times_names[i].c_str(), yyvsp[-1].text))
      break;
  }
  if (i < number_of_times) {	/* Found it! */
    current_block = &(times_buffer[i]);
    current_time_index = i;
  } else
    gnans_error(semantic, "`%s' is not a declared time", yyvsp[-1].text);
}
    break;

  case 16:
#line 275 "parser.yy"
    { putsym(yyvsp[0].text, Formal_Parameter);
				  yyval.text = stringify("double %s", yyvsp[0].text); }
    break;

  case 17:
#line 281 "parser.yy"
    { yyval.text = stringify("%s, %s, %s", yyvsp[-4].text, yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 18:
#line 283 "parser.yy"
    { yyval.text = stringify("%s,%s", yyvsp[-2].text,yyvsp[0].text); }
    break;

  case 22:
#line 292 "parser.yy"
    {
  fprintf(zzout, "static double %s(%s){return %s;}\n", yyvsp[-6].text, yyvsp[-4].text, yyvsp[-1].text);
  fprintf(zzout, "extern void NeVeR_CaLlEd_%s(){%s(0);}\n", yyvsp[-6].text, yyvsp[-6].text);
  symtab_delete_type(Formal_Parameter);
  current_dependencies = NULL;
  put_unique_sym(yyvsp[-6].text, Defun);
  add_unary_function(yyvsp[-6].text);
}
    break;

  case 23:
#line 303 "parser.yy"
    {
  fprintf(zzout, "static double %s(%s,%s){return %s;}\n", yyvsp[-8].text, yyvsp[-6].text, yyvsp[-4].text, yyvsp[-1].text);
  fprintf(zzout, "extern void NeVeR_CaLlEd_%s(){%s(0,0);}\n", yyvsp[-8].text, yyvsp[-8].text);
  symtab_delete_type(Formal_Parameter);
  current_dependencies = NULL;
  put_unique_sym(yyvsp[-8].text, Defun);
  add_binary_function(yyvsp[-8].text);
}
    break;

  case 24:
#line 314 "parser.yy"
    {
  fprintf(zzout, "static double %s(%s){return %s;}\n", yyvsp[-6].text, yyvsp[-4].text, yyvsp[-1].text);
  fprintf(zzout, "extern void *NeVeR_CaLlEd_%s(){ return (void*)%s;}\n",
	    yyvsp[-6].text, yyvsp[-6].text);
  symtab_delete_type(Formal_Parameter);
  current_dependencies = NULL;
  put_unique_sym(yyvsp[-6].text, Defun);
}
    break;

  case 36:
#line 345 "parser.yy"
    {
  if (system_type != riccati)
    gnans_error(semantic, "Riccati equations only allowed in Riccati systems");
  symrec *thestate = getsym(yyvsp[-15].text);
  if (thestate) {
    if (thestate->type != State_matrix)
      gnans_error(semantic,
		  "`%s' is not a state matrix; "
		  "it cannot have a differential Riccati equation",
		  yyvsp[-15].text);
    if (thestate->equation)
      gnans_error(semantic, "Repeated equation for `d(%s)'", yyvsp[-15].text);
    
    if (!STR_EQUAL(yyvsp[-15].text, yyvsp[-10].text))
      gnans_error(semantic, "First argument of RICCATI must be the state matrix");
    if (!getsym(yyvsp[-8].text))
      gnans_error(semantic, "`%s' is not defined", yyvsp[-8].text);
    if (!getsym(yyvsp[-6].text))
      gnans_error(semantic, "`%s' is not defined", yyvsp[-6].text);
    if (!getsym(yyvsp[-4].text))
      gnans_error(semantic, "`%s' is not defined", yyvsp[-4].text);
    if (!getsym(yyvsp[-2].text))
      gnans_error(semantic, "`%s' is not defined", yyvsp[-2].text);
  
    if (!((getsym(yyvsp[-8].text)->type == Parameter_matrix) &&
	  (getsym(yyvsp[-6].text)->type == Parameter_matrix) &&
	  (getsym(yyvsp[-4].text)->type == Parameter_matrix) &&
	  (getsym(yyvsp[-2].text)->type == Parameter_matrix)))
      gnans_error(semantic,
		  "Arguments 2, 3, 4, and 5 of RICCATI "
		  "must be parameter matrices");
  
    if (current_block_compare(STARTINDEX))
      gnans_error(semantic, "Riccati equations not allowed in AT TIME START");
    if (current_block_compare(STOPINDEX))
      gnans_error(semantic, "Riccati equations not allowed in AT TIME STOP");
    if (current_block_compare(STOREINDEX))
      gnans_error(semantic, "Riccati equations not allowed in AT TIME STORE");
    if (current_block_compare(ACCEPTEDINDEX))
      gnans_error(semantic, "Riccati equations not allowed in AT TIME ACCEPTED");
    thestate->a_priori_timeindex = current_time_index;

    thestate->equation = stringify("//RICCATI(%s,%s,%s,%s,%s)",
				   yyvsp[-10].text, yyvsp[-8].text, yyvsp[-6].text, yyvsp[-4].text, yyvsp[-2].text);
    thestate->dependencies = current_dependencies;
    thestate->line_no_of_equation = lineno;
    current_dependencies = NULL;
    riccati_data.A21 = getsym(yyvsp[-8].text);
    riccati_data.A22 = getsym(yyvsp[-6].text);
    riccati_data.A11 = getsym(yyvsp[-4].text);
    riccati_data.A12 = getsym(yyvsp[-2].text);
  }
  else
    gnans_error(semantic, "`%s' is not defined", yyvsp[-15].text);
}
    break;

  case 37:
#line 403 "parser.yy"
    {
  symrec *thestate, *thewiener, *sym;
  unsigned int i;
  if (system_type == discrete || system_type == riccati)
    gnans_error(semantic,
		"Diffential equations are not allowed in discrete time systems");
  thestate = getsym(yyvsp[-4].text);
  if (thestate) {
    if (thestate->type != State)
      gnans_error(semantic,
		  "`%s' is not a state; it cannot have a differential equation",
		  yyvsp[-4].text);
    if (thestate->equation)
      gnans_error(semantic, "Repeated equation for `d(%s)'", yyvsp[-4].text);
    if (current_block_compare(STARTINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME START");
    if (current_block_compare(STOPINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME STOP");
    if (current_block_compare(STOREINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME STORE");
    if (current_block_compare(ACCEPTEDINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME ACCEPTED");
    thestate->a_priori_timeindex = current_time_index;
    thestate->equation = yyvsp[-1].text;
    thestate->dependencies = current_dependencies;
    thestate->line_no_of_equation = lineno;
    current_dependencies = NULL;

    for (i = 0; i < number_of_wieners; i++) {
      thewiener = getsym((char*)wieners[i] + 2);	/* Zap the "d_" */
      sym = put_unique_sym(stringify("%s_d_%s", thestate->name,
				     thewiener->name), Wiener_coeff);
      sym->equation = stringify("0");
      sym->dependencies = NULL;
      sym->line_no_of_equation = lineno;
    }
  }
  else
    gnans_error(semantic, "`%s' is not defined", yyvsp[-4].text);
}
    break;

  case 38:
#line 446 "parser.yy"
    {
  symrec *thestate;
  if (system_type != discrete)
    gnans_error(semantic, "Diffence equations only allowed in discrete time systems");
  thestate = getsym(yyvsp[-4].text);
  if (thestate) {
    if (thestate->type != State)
      gnans_error(semantic,
		  "`%s' is not a state; it cannot have a difference equation",
		  yyvsp[-4].text);
    if (thestate->equation)
      gnans_error(semantic, "Repeated equation for `d(%s)'", yyvsp[-4].text);
    if (current_block_compare(STARTINDEX))
      gnans_error(semantic, "Difference equations not allowed in AT TIME START");
    if (current_block_compare(STOPINDEX))
      gnans_error(semantic, "Difference equations not allowed in AT TIME STOP");
    if (current_block_compare(STOREINDEX))
      gnans_error(semantic, "Difference equations not allowed in AT TIME STORE");
    if (current_block_compare(ACCEPTEDINDEX))
      gnans_error(semantic, "Difference equations not allowed in AT TIME ACCEPTED");
    thestate->a_priori_timeindex = current_time_index;
    thestate->equation = yyvsp[-1].text;
    thestate->dependencies = current_dependencies;
    thestate->line_no_of_equation = lineno;
  }
  else
    gnans_error(semantic, "`%s' is not defined", yyvsp[-4].text);
  current_dependencies = NULL;
}
    break;

  case 39:
#line 477 "parser.yy"
    {
  symrec *thevariable;
  if (system_type == riccati)
    gnans_error(semantic, "Algebraic equations not allowed in Riccati systems");
  thevariable = getsym(yyvsp[-3].text);
  if (thevariable) {
    if (current_block_compare(ACCEPTEDINDEX))
      gnans_error(semantic, "Equations not allowed in AT TIME ACCEPTED");
    if (current_block_compare(STOREINDEX))
      gnans_error(semantic, "Equations not allowed in AT TIME STORE");
    if (current_block_compare(STOPINDEX))
      gnans_error(semantic, "Equations not allowed in AT TIME STOP");
    if (thevariable->type == State)
      gnans_error(semantic, "`%s' can only have a dynamic equation", yyvsp[-3].text);
    if ((thevariable->type != Variable) && (thevariable->type != Function))
      gnans_error(semantic,
		  "`%s' cannot be have an equation (only variables and functions)", yyvsp[-3].text);
    if (thevariable->equation)
      gnans_error(semantic, "Repeated equation for `%s'", yyvsp[-3].text);
    thevariable->a_priori_timeindex = current_time_index;
    thevariable->equation = yyvsp[-1].text;
    thevariable->dependencies = current_dependencies;
    thevariable->line_no_of_equation = lineno;
  }
  else
    gnans_error(semantic, "`%s' is not defined", yyvsp[-3].text);
  current_dependencies = NULL;
}
    break;

  case 40:
#line 507 "parser.yy"
    {
}
    break;

  case 41:
#line 512 "parser.yy"
    {
  symrec *thestate, *thewiener, *sym;
  unsigned int i;
  if (system_type == discrete)
    gnans_error(semantic,
		"Diffential equations are not allowed in discrete time systems");
  thestate = getsym(yyvsp[-5].text);
  if (thestate) {
    if (thestate->type != State)
      gnans_error(semantic,
		  "`%s' is not a state; it cannot have a differential equation", yyvsp[-5].text);
    if (thestate->equation)
      gnans_error(semantic, "Repeated equation for `d(%s)'", yyvsp[-5].text);
    if (current_block_compare(STARTINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME START");
    if (current_block_compare(STOPINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME STOP");
    if (current_block_compare(STOREINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME STORE");
    if (current_block_compare(ACCEPTEDINDEX))
      gnans_error(semantic, "Differential equations not allowed in AT TIME ACCEPTED");
    thestate->a_priori_timeindex = current_time_index;
    thestate->equation = current_drift ? current_drift : stringify("0");
    current_drift = NULL;
    thestate->dependencies = current_drift_dependencies;
    current_drift_dependencies = NULL;
    thestate->line_no_of_equation = lineno;
    current_dependencies = NULL;

    for (i = 0; i < number_of_wieners; i++) {
      thewiener = getsym((char*)wieners[i] + 2);	/* Zap the "d_" */
      sym = put_unique_sym(stringify("%s_d_%s", thestate->name,
				     thewiener->name), Wiener_coeff);
      sym->equation = thewiener->equation ? thewiener->equation : stringify("0");
      thewiener->equation = NULL;
      sym->dependencies = thewiener->dependencies;
      thewiener->dependencies = NULL;
      sym->line_no_of_equation = lineno;
    }
  }
  else
    gnans_error(semantic, "`%s' is not defined", yyvsp[-5].text);
}
    break;

  case 45:
#line 562 "parser.yy"
    { current_drift = stringify("%s", "0");
			  current_drift_dependencies = NULL;
			  current_dependencies = NULL;}
    break;

  case 46:
#line 566 "parser.yy"
    {
  unsigned int i;
  if (time_variable_name ==  yyvsp[-1].text) {
    /* This is the drift term */

    /* Barf on several drift vector fields */
    if (current_drift)
      gnans_error(semantic, "Only one drift vector field is allowed.");
    current_drift = stringify("%s", yyvsp[-4].text);
    current_drift_dependencies = current_dependencies;
    current_dependencies = NULL;
  } else {
    for (i = 0; i < number_of_wieners; i++)
      if (STR_EQUAL(wieners[i], stringify("d_%s", yyvsp[-1].text)))
	break;
    if (i == number_of_wieners)
      gnans_error(semantic, "``d(%s)'' doesn't make sense here", yyvsp[-1].text);
    else {
      symrec *the_wiener;
      the_wiener = getsym(yyvsp[-1].text);	/* WILL succeed, don't check */
      if (the_wiener->equation)
	gnans_error(semantic, "Only one drift vector field for %s allowed.",
		    the_wiener->name);
      the_wiener->equation = stringify("%s", yyvsp[-4].text);
      the_wiener->dependencies = current_dependencies;
      current_dependencies = NULL;
    }
  }
}
    break;

  case 47:
#line 598 "parser.yy"
    {
  unsigned int i;
  if (time_variable_name == yyvsp[-1].text) {
    /* This is the drift term */

    /* Barf on several drift vector fields */
    if (current_drift)
      gnans_error(semantic, "Only one drift vector field is allowed.");
    current_drift = stringify("-%s", yyvsp[-4].text);
    current_drift_dependencies = current_dependencies;
    current_dependencies = NULL;
  } else {
    for (i = 0; i < number_of_wieners; i++)
      if (STR_EQUAL(wieners[i], stringify("d_%s", yyvsp[-1].text)))
	break;
    if (i == number_of_wieners)
      gnans_error(semantic, "``d(%s)'' doesn't make sense here", yyvsp[-1].text);
    else {
      symrec *the_wiener;
      the_wiener = getsym(yyvsp[-1].text);	/* WILL succeed, don't check */
      if (the_wiener->equation)
	gnans_error(semantic, "Only one drift vector field for %s allowed.",
		    the_wiener->name);
      the_wiener->equation = stringify("-%s", yyvsp[-4].text);
      the_wiener->dependencies = current_dependencies;
      current_dependencies = NULL;
    }
  }
}
    break;

  case 48:
#line 629 "parser.yy"
    { yyval.text = stringify("1"); }
    break;

  case 49:
#line 630 "parser.yy"
    { yyval.text = yyvsp[-1].text; }
    break;

  case 50:
#line 633 "parser.yy"
    { yyval.text = stringify(FLOATFMT,yyvsp[0].value); }
    break;

  case 51:
#line 634 "parser.yy"
    { yyval.text = stringify("%d.0", yyvsp[0].integer); }
    break;

  case 52:
#line 635 "parser.yy"
    { add_dependency(yyvsp[0].text); yyval.text = yyvsp[0].text; }
    break;

  case 53:
#line 636 "parser.yy"
    { /*!!!!*/add_dependency(yyvsp[-1].text);
					   yyval.text = stringify("q(%s)", yyvsp[-1].text); }
    break;

  case 54:
#line 639 "parser.yy"
    { yyval.text = stringify("%s %s", yyvsp[-1].text, yyvsp[0].text); }
    break;

  case 55:
#line 641 "parser.yy"
    { yyval.text = operation("%s %s", yyvsp[-1].text, yyvsp[0].text); }
    break;

  case 56:
#line 642 "parser.yy"
    { yyval.text = operation("%s()", yyvsp[-2].text);
					 increment_function_calls(yyvsp[-2].text, 0); }
    break;

  case 57:
#line 644 "parser.yy"
    { yyval.text = operation("%s(%s)", yyvsp[-3].text, yyvsp[-1].text);
					 increment_function_calls(yyvsp[-3].text, 1); }
    break;

  case 58:
#line 647 "parser.yy"
    { yyval.text = operation("%s(%s,%s)", yyvsp[-5].text, yyvsp[-3].text, yyvsp[-1].text);
                                  increment_function_calls(yyvsp[-5].text, 2); }
    break;

  case 59:
#line 650 "parser.yy"
    { yyval.text = operation("%s(%s,%s,%s)", yyvsp[-7].text, yyvsp[-5].text, yyvsp[-3].text, yyvsp[-1].text);
					 increment_function_calls(yyvsp[-7].text, 3); }
    break;

  case 60:
#line 653 "parser.yy"
    { yyval.text = operation("%s%s", yyvsp[-1].text, yyvsp[0].text); }
    break;

  case 61:
#line 654 "parser.yy"
    { yyval.text = operation("%s+%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 62:
#line 655 "parser.yy"
    { yyval.text = operation("%s-%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 63:
#line 656 "parser.yy"
    { yyval.text = operation("%s*%s", yyvsp[-2].text, yyvsp[0].text);}
    break;

  case 64:
#line 657 "parser.yy"
    { yyval.text = operation("%s/%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 65:
#line 658 "parser.yy"
    { yyval.text = operation("fmod(%s,%s)", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 66:
#line 659 "parser.yy"
    { yyval.text = operation("++%s", yyvsp[0].text); }
    break;

  case 67:
#line 660 "parser.yy"
    { yyval.text = operation("--%s", yyvsp[0].text); }
    break;

  case 68:
#line 661 "parser.yy"
    { yyval.text = operation("%s++", yyvsp[-1].text); }
    break;

  case 69:
#line 662 "parser.yy"
    { yyval.text = operation("%s--", yyvsp[-1].text); }
    break;

  case 70:
#line 663 "parser.yy"
    { yyval.text = operation("-%s", yyvsp[0].text); }
    break;

  case 71:
#line 664 "parser.yy"
    { yyval.text = operation("-%s", yyvsp[0].text); }
    break;

  case 72:
#line 665 "parser.yy"
    { yyval.text = operation("!%s", yyvsp[0].text); }
    break;

  case 73:
#line 666 "parser.yy"
    { yyval.text = operation("~%s", yyvsp[0].text); }
    break;

  case 74:
#line 667 "parser.yy"
    { yyval.text = operation("pow((double)%s,(double)%s)",
						  yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 75:
#line 669 "parser.yy"
    { yyval.text = operation("(%s)", yyvsp[-1].text); }
    break;

  case 76:
#line 670 "parser.yy"
    { yyval.text = operation("%s<<%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 77:
#line 671 "parser.yy"
    { yyval.text = operation("%s>>%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 78:
#line 672 "parser.yy"
    { yyval.text = operation("%s==%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 79:
#line 673 "parser.yy"
    { yyval.text = operation("%s!=%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 80:
#line 674 "parser.yy"
    { yyval.text = operation("%s<=%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 81:
#line 675 "parser.yy"
    { yyval.text = operation("%s>=%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 82:
#line 676 "parser.yy"
    { yyval.text = operation("%s<%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 83:
#line 677 "parser.yy"
    { yyval.text = operation("%s>%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 84:
#line 678 "parser.yy"
    { yyval.text = operation("%s&%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 85:
#line 679 "parser.yy"
    { yyval.text = operation("%s|%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 86:
#line 680 "parser.yy"
    { yyval.text = operation("%s&&%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 87:
#line 681 "parser.yy"
    { yyval.text = operation("%s||%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 88:
#line 682 "parser.yy"
    { yyval.text = operation("%s?%s:%s", yyvsp[-4].text, yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 89:
#line 685 "parser.yy"
    { yyval.text = yyvsp[0].text; }
    break;

  case 90:
#line 686 "parser.yy"
    { yyval.text = stringify("%s.%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 91:
#line 689 "parser.yy"
    { yyval.text = stringify("%s", yyvsp[0].text); }
    break;

  case 92:
#line 691 "parser.yy"
    { yyval.text = stringify("%s,%s", yyvsp[-2].text, yyvsp[0].text); }
    break;

  case 93:
#line 694 "parser.yy"
    { yyval.text = stringify("(int)"); }
    break;

  case 94:
#line 697 "parser.yy"
    { yyval.text = stringify("(double)"); }
    break;

  case 95:
#line 700 "parser.yy"
    { yyval.text = stringify("[(int)%s]", yyvsp[-1].text); }
    break;

  case 96:
#line 702 "parser.yy"
    { yyval.text = stringify("%s[(int)%s]", yyvsp[-3].text, yyvsp[-1].text); }
    break;

  case 97:
#line 705 "parser.yy"
    {
  check_size(number_of_times);
  put_unique_sym(yyvsp[-1].text, Time_type);
  times_buffer[number_of_times] = "";
  time_variable_name = yyvsp[-1].text;
  times_names[number_of_times++] = yyvsp[-1].text;
}
    break;

  case 104:
#line 723 "parser.yy"
    { yyval.text = yyvsp[0].text;}
    break;

  case 105:
#line 727 "parser.yy"
    {
		  system_type = continuous;
		  system_name = yyvsp[-1].text; }
    break;

  case 106:
#line 733 "parser.yy"
    {
		  system_type = discrete; 
		  system_name = yyvsp[-1].text; }
    break;

  case 107:
#line 739 "parser.yy"
    { system_type = hybrid; 
					    system_name = yyvsp[-1].text; }
    break;

  case 108:
#line 744 "parser.yy"
    { system_type = das; 
					  system_name = yyvsp[-1].text; }
    break;

  case 109:
#line 749 "parser.yy"
    {system_type = riccati; 
					     system_name = yyvsp[-1].text; }
    break;

  case 121:
#line 768 "parser.yy"
    {}
    break;

  case 122:
#line 771 "parser.yy"
    {}
    break;

  case 125:
#line 778 "parser.yy"
    {
  check_size(number_of_states, MAXSTATES);
  put_unique_sym(yyvsp[-3].text, State);
  states[number_of_states] = yyvsp[-3].text;
  states[number_of_states].initial = yyvsp[-1].value;
  states[number_of_states++].documentation = stringify("%s", yyvsp[0].text);
  fprintf(zzout, "static UserParameter gnans_state_%s;\n", yyvsp[-3].text);
}
    break;

  case 126:
#line 790 "parser.yy"
    { gnans_error(semantic, "VECTOR not yet implemented"); }
    break;

  case 127:
#line 795 "parser.yy"
    { check_size(number_of_state_matrices);
		    if (system_type != riccati)
		      gnans_error(semantic, "MATRIX not yet implemented");
		    if (number_of_state_matrices)
		      gnans_error(semantic, "Only one STATE MATRIX allowed");
		    put_unique_sym(yyvsp[-11].text, State_matrix);
		    state_matrices[number_of_state_matrices] = yyvsp[-11].text;
		    state_matrices[number_of_state_matrices].filename
		      = stringify("%s", yyvsp[-5].text);
		    state_matrices[number_of_state_matrices].external_name
		      = stringify("%s", yyvsp[-3].text);
		    //states[number_of_states].initial = 0;
		    state_matrices[number_of_state_matrices++].documentation
		      = stringify("%s", yyvsp[-1].text);
		    if (!STR_EQUAL(yyvsp[-7].text, "matlab"))
		      gnans_error(semantic,
				  "Only Matlab format presently implemented");
		    fprintf(zzout, 
			    "static user_matrix gnans_state_matrix_%s;\n", yyvsp[-11].text);
}
    break;

  case 128:
#line 817 "parser.yy"
    {}
    break;

  case 131:
#line 825 "parser.yy"
    {
  /* Presently, we treat the integer states really stepmotherly */
  put_unique_sym(yyvsp[-3].text, Integer_State);
  c_declarations += "int " + std::string(yyvsp[-3].text) + " = " + number_String(yyvsp[-1].integer)
    + "; /* " + yyvsp[0].text + " */\n" ;
  times_buffer[STARTINDEX] += stringify("  %s = %d;\n", yyvsp[-3].text, yyvsp[-1].integer);
}
    break;

  case 134:
#line 836 "parser.yy"
    {}
    break;

  case 135:
#line 839 "parser.yy"
    {}
    break;

  case 138:
#line 846 "parser.yy"
    {
  check_size(number_of_parameters, MAXSTATES);
  put_unique_sym(yyvsp[-3].text, Parameter);
  parameters[number_of_parameters] = yyvsp[-3].text;
  parameters[number_of_parameters].initial = yyvsp[-1].value;
  parameters[number_of_parameters++].documentation = stringify("%s", yyvsp[0].text);
  
  fprintf(zzout, "static UserParameter gnans_parameter_%s;\n", yyvsp[-3].text);
}
    break;

  case 139:
#line 859 "parser.yy"
    { gnans_error(semantic, "VECTOR not yet implemented"); }
    break;

  case 140:
#line 864 "parser.yy"
    {
  check_size(number_of_parameter_matrices);
  if (system_type != riccati)
    gnans_error(semantic, "MATRIX not yet implemented");
  put_unique_sym(yyvsp[-11].text, Parameter_matrix);
  parameter_matrices[number_of_parameter_matrices] = yyvsp[-11].text;
  parameter_matrices[number_of_parameter_matrices].filename
    = stringify("%s", yyvsp[-5].text);
  parameter_matrices[number_of_parameter_matrices].external_name
    = stringify("%s", yyvsp[-3].text);
  parameter_matrices[number_of_parameter_matrices++].documentation
    = stringify("%s", yyvsp[-1].text);
  if (!STR_EQUAL(yyvsp[-7].text, "matlab"))
    gnans_error(semantic, "Only Matlab format presently implemented");
  fprintf(zzout, "static user_matrix gnans_parameter_matrix_%s;\n", yyvsp[-11].text);
}
    break;

  case 141:
#line 882 "parser.yy"
    {}
    break;

  case 144:
#line 889 "parser.yy"
    {
  check_size(number_of_functions, MAXSTATES);
  put_unique_sym(yyvsp[-1].text, Function);
  functions[number_of_functions] = yyvsp[-1].text;
  functions[number_of_functions++].documentation = stringify("%s", yyvsp[0].text);
  fprintf(zzout, "static UserParameter gnans_function_%s;\n", yyvsp[-1].text);
}
    break;

  case 145:
#line 898 "parser.yy"
    {}
    break;

  case 148:
#line 905 "parser.yy"
    {
  check_size(number_of_variables, MAXSTATES);
  put_unique_sym(yyvsp[0].text, Variable);
  variables[number_of_variables++] = yyvsp[0].text;
  fprintf(zzout, "static double gnans_variable_%s;\n", yyvsp[0].text);
}
    break;

  case 149:
#line 913 "parser.yy"
    {}
    break;

  case 152:
#line 920 "parser.yy"
    {
  put_unique_sym(yyvsp[0].text, C_Identifier);
}
    break;

  case 153:
#line 925 "parser.yy"
    {}
    break;

  case 156:
#line 932 "parser.yy"
    {
  check_size(number_of_randoms, MAXSTATES);
  check_size(number_of_uniforms, MAXSTATES);
  put_unique_sym(yyvsp[-3].text, Uniform_Noise);
  randoms[number_of_randoms] = yyvsp[-3].text;
  randoms[number_of_randoms].initial = yyvsp[-1].integer;
  randoms[number_of_randoms++].documentation = stringify("%s", yyvsp[0].text);
  uniforms[number_of_uniforms] = yyvsp[-3].text;
  uniforms[number_of_uniforms].initial = yyvsp[-1].integer;
  uniforms[number_of_uniforms++].documentation = stringify("%s", yyvsp[0].text);
  fprintf(zzout, "static UserParameter gnans_random_%s;\n", yyvsp[-3].text);
}
    break;

  case 157:
#line 945 "parser.yy"
    {}
    break;

  case 160:
#line 952 "parser.yy"
    {
  check_size(number_of_randoms, MAXSTATES);
  check_size(number_of_normals, MAXSTATES);
  put_unique_sym(yyvsp[-3].text, Normal_Noise);
  randoms[number_of_randoms] = yyvsp[-3].text;
  randoms[number_of_randoms].initial = yyvsp[-1].integer;
  randoms[number_of_randoms++].documentation = stringify("%s", yyvsp[0].text);
  normals[number_of_normals] = yyvsp[-3].text;
  normals[number_of_normals].initial = yyvsp[-1].integer;
  normals[number_of_normals++].documentation = stringify("%s", yyvsp[0].text);
  fprintf(zzout, "static UserParameter gnans_random_%s;\n", yyvsp[-3].text);
}
    break;

  case 161:
#line 965 "parser.yy"
    {}
    break;

  case 164:
#line 972 "parser.yy"
    {
  check_size(number_of_randoms, MAXSTATES);
  check_size(number_of_wieners, MAXSTATES);
  put_unique_sym(yyvsp[-3].text, Wiener_Process);
  std::string name = std::string("d_") + yyvsp[-3].text;
  randoms[number_of_randoms] = name;
  randoms[number_of_randoms].initial = yyvsp[-1].integer;
  randoms[number_of_randoms++].documentation = stringify("%s", yyvsp[0].text);
  wieners[number_of_wieners] = name;
  wieners[number_of_wieners].initial = yyvsp[-1].integer;
  wieners[number_of_wieners++].documentation = stringify("%s", yyvsp[0].text);
  fprintf(zzout, "static UserParameter gnans_random_%s;\n", name.c_str());
}
    break;

  case 165:
#line 987 "parser.yy"
    { yyval.text = dummy_string; }
    break;

  case 166:
#line 988 "parser.yy"
    {
                            /* Zap last `"' */
		            zztext[strlen((const char *) zztext) - 1] = '\0';
			    /* Zap first `"`, and make a copy */
			    yyval.text = stringify("%s", (char *) zztext + 1);
			  }
    break;

  case 167:
#line 996 "parser.yy"
    { yyval.value = yyvsp[0].value; }
    break;

  case 168:
#line 997 "parser.yy"
    { yyval.value = -yyvsp[0].value; }
    break;

  case 169:
#line 998 "parser.yy"
    { yyval.value = (double) yyvsp[0].integer; }
    break;

  case 170:
#line 999 "parser.yy"
    { yyval.value = - (double) yyvsp[0].integer; }
    break;

  case 174:
#line 1005 "parser.yy"
    { gnans_error(impossible, "");
#if 0
#ifdef YYBISON
			    if (lineno)	/* To prevent complains... */
			      goto zzerrlab1;
			    else
			      goto zzbackup;
#else
			    if (lineno)	/* To prevent complains... */
			      goto zzerrlab;
			    else
			      goto zznewstate;
#endif
#endif
}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2625 "parser.cc"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1021 "parser.yy"


